/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.shared;

import java.math.BigInteger;
import ru.ispras.microtesk.model.api.data.TypeId;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.api.memory.Memory;
import ru.ispras.microtesk.model.api.memory.Label;

public final class Shared {
  private Shared() {}


  public static final Type INDEX = Type.def("INDEX", Type.CARD(8));
  public static final Type NIBBLE = Type.def("NIBBLE", Type.CARD(4));
  public static final Type BYTE = Type.def("BYTE", Type.INT(8));

  public static final Memory GPR = Memory.def(Memory.Kind.REG, "GPR", BYTE, 0x10);
  public static final Memory PC = Memory.def(Memory.Kind.REG, "PC", INDEX, 0x1);
  public static final Memory M = Memory.def(Memory.Kind.MEM, "M", BYTE, 0x100);
  public static final Memory SRC1 = Memory.def(Memory.Kind.VAR, "SRC1", BYTE, 0x1);
  public static final Memory SRC2 = Memory.def(Memory.Kind.VAR, "SRC2", BYTE, 0x1);
  public static final Memory DEST = Memory.def(Memory.Kind.VAR, "DEST", BYTE, 0x1);

  public static final Memory[] __REGISTERS = {GPR, PC};
  public static final Memory[] __MEMORY = {M};
  public static final Memory[] __VARIABLES = {SRC1, SRC2, DEST};
  public static final Label[] __LABELS = {};
}
 