/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class jr extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         jr.class,
         "jr",
         false,
         new ArgumentDecls()
             .add("addr", ArgumentMode.IN, REG.INFO),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG addr = (REG) getArgument("addr", args);

      return new jr(addr);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "jr",
          true,
          new ArgumentDecls()
              .add("addr", ArgumentMode.IN, REG.INFO),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG addr = (REG) getArgument("addr", args);

      return new instruction(
        new jr(
          addr
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final REG addr;

  public jr(final REG addr) {
    assert REG.INFO.isSupported(addr);
    this.addr = addr;
  }

  @Override
  public String syntax() {
    return String.format("jr %s", addr.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%s000000000000000000000", addr.image());
  }

  @Override
  public void action() {
    BRANCH.access().store(Data.valueOf(BIT, 0x1));
    JMPADDR.access().store(addr.access().load());
  }
}
