/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class SLTI extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SLTI.class,
         "SLTI",
         false,
         new ArgumentDecls()
             .add("rt", ArgumentMode.OUT, R.INFO)
             .add("rs", ArgumentMode.IN, R.INFO)
             .add("imm", SHORT),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new SLTI(rt, rs, imm);
    }
  }

  public static final IInfo INFO = new Info();

  public final R rt;
  public final R rs;
  public final Immediate imm;

  public SLTI(final R rt, final R rs, final Immediate imm) {
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rs);
    assert SHORT.equals(imm.getType());
    this.rt = rt;
    this.rs = rs;
    this.imm = imm;
  }

  @Override
  public String syntax() {
    return String.format("SLTI %s, %s, 0x%x", rt.syntax(), rs.syntax(), imm.access().load().bigIntegerValue(false));
  }

  @Override
  public String image() {
    return String.format("001010%s%s%s", rs.image(), rt.image(), imm.access().load().toString());
  }

  @Override
  public void action() {
    rt.access().store(Data.valueOf(WORD, ((rs.access().load().compareTo(Data.signExtend(WORD, imm.access().load())) < 0) ? 1 : 0)));
  }
}
